
// -------------------------------------------------------------------- create websites
void createHtml() {
  wsHome = "\
 <html>\
    <meta name='theme-color' content='#cccc00' />\
    <meta http-equiv='content-type' content='text/html; charset=utf-8'>\
    <meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no' />\
    <meta name='HandheldFriendly' content='true' />\
    <style>\
        body        {background-color:yellow;margin:0;padding:0;font-family: monospace;}\
        #headline   {position: absolute; color: black; display: flex;justify-content: center;align-items: center;}\
        #can        {position: absolute; border:solid 2px;touch-action: none;}\
        #clear      {position: absolute;background-color: magenta; color: black;cursor: pointer;border:solid 2px; margin:0px;}\
        #print      {position: absolute;background-color: cyan;    color: black;cursor: pointer; border:solid 2px; margin:0px;}\
        #memUse     {position: absolute;background-color: white;   color: black; border:solid 2px;display: flex;justify-content: center;align-items: center;}\
        #memUseBar  {position: absolute;background-color: rgba(0,255,255,.5);    color: black; border:solid 2px;}\
        #printForm  {display: none; position:absolute; top:100vh;width:100%;height:100%;overflow-wrap: anywhere;}\
    </style>\
    <script type='text/javascript'>\
    var canvas, ctx,\
        pX = 0,\
        x = 0,\
        pY = 0,\
        y = 0,\
        draw = false,\
        drawDot = false;\
    var maxLines = 500;\
    var xLog=[];\
    var yLog=[];\
    var size;\
    var yOffset = 0;\
    function layout(){\
      var sW =  window.innerWidth;\
      var sH =  window.innerHeight;\
      if (sW < sH) {\
        size = sW*.9;\
        yOffset = (sH-size*1.6)/4;\
        if(size*1.7+yOffset>sH){\
          size = 0.57 * sH;\
          yOffset = (sH-size*1.6)/4;\
          }\
      }else{\
        size = sH*.6;\
        yOffset = 0;\
      }\
      var left = sW/2 - size/2;\
      hea = document.getElementById('headline');\
      hea.style.width       = size  ;\
      hea.style.left        = left;\
      hea.style.height      = size*.2 + yOffset;\
      hea.style.fontSize    = size * .08 +'px';\
      canvas = document.getElementById('can');\
      ctx = canvas.getContext('2d');\
      ctx.canvas.width      = size;\
      ctx.canvas.height     = size;\
      ctx.canvas.style.left = left;\
      ctx.canvas.style.top  = size *.2 + yOffset;\
      mUs = document.getElementById('memUse');\
      mUs.style.width       = size  ;\
      mUs.style.height      = size  *.1;\
      mUs.style.left        = left  ;\
      mUs.style.top         = size  *1.3 + yOffset;\
      mUs.style.fontSize    = size * .05 +'px';\
      mUs.innerText   = 'SPEICHER:'+Math.round(xLog.length*100/maxLines)+'%';\
      mUB = document.getElementById('memUseBar');\
      mUB.style.width       = size * xLog.length/maxLines;\
      mUB.style.height      = size  *.1;\
      mUB.style.left        = left  ;\
      mUB.style.top         = size  *1.3 + yOffset;\
      clr = document.getElementById('clear');\
      clr.style.width       = size  *.45;\
      clr.style.height      = size  *.2;\
      clr.style.left        = left;\
      clr.style.top         = size  *1.5 + yOffset;\
      clr.style.fontSize    = size * .05 +'px';\
      prn = document.getElementById('print');\
      prn.style.width       = size  *.45;\
      prn.style.height      = size  *.2;\
      prn.style.left        = left  +size - size*.45;\
      prn.style.top         = size  *1.5 + yOffset;\
      prn.style.fontSize    = size * .05 +'px';\
      w = canvas.width;\
      h = canvas.height;\
      ctx.fillStyle = '#FFFFFF';\
      ctx.lineWidth = 2;\
      ctx.beginPath();\
      ctx.fillRect(1, 1, w-2, h-2);\
      ctx.stroke();\
      for (var i=0; i<xLog.length - 1;i+=2) {\
            ctx.beginPath();\
            ctx.moveTo( xLog[i]*size,   yLog[i]*size   );\
            ctx.lineTo( xLog[i+1]*size, yLog[i+1]*size );\
            ctx.stroke();\
        }\
    }\
    function init() {\
        document.getElementById('printForm').value = 'LINEDRAWING-';\
        layout();\
        canvas.addEventListener('touchmove', function (e) {\
            action('move', e)\
        }, false);\
        canvas.addEventListener('touchstart', function (e) {\
            action('down', e)\
        }, false);\
       canvas.addEventListener('touchend', function (e) {\
            action('up', e)\
        }, false);\
        canvas.addEventListener('mouseout', function (e) {\
            action('out', e)\
        }, false);\
    }\
    function action(res, e) {\
      if (res == 'up' || res == 'out') {\
        if (drawDot && xLog.length<maxLines-4){\
          ctx.beginPath();\
          ctx.moveTo(x-2,y-2);\
          ctx.lineTo(x+2,y+2);\
          ctx.stroke();\
          xLog.push((x-2)/size);\
          xLog.push((x+2)/size);\
          yLog.push((y-2)/size);\
          yLog.push((y+2)/size);\
          ctx.beginPath();\
          ctx.moveTo(x+2,y-2);\
          ctx.lineTo(x-2,y+2);\
          ctx.stroke();\
          xLog.push((x+2)/size);\
          xLog.push((x-2)/size);\
          yLog.push((y-2)/size);\
          yLog.push((y+2)/size);\
          xa = Math.round((x-2)/size*899+100);\
          ya = Math.round((y-2)/size*899+100);\
          xb = Math.round((x+2)/size*899+100);\
          yb = Math.round((y+2)/size*899+100);\
          if (xa<100){xa=100;}\
          if (xb<100){xb=100;}\
          if (ya<100){ya=100;}\
          if (yb<100){yb=100;}\
          if (xa>999){xa=999;}\
          if (xb>999){xb=999;}\
          if (ya>999){ya=999;}\
          if (yb>999){yb=999;}\
          document.getElementById('printForm').value += '_'+xa +'.'+ ya +'.'+ xb +'.'+ yb;\
          xa = Math.round((x+2)/size*899+100);\
          ya = Math.round((y-2)/size*899+100);\
          xb = Math.round((x-2)/size*899+100);\
          yb = Math.round((y+2)/size*899+100);\
          if (xa<100){xa=100;}\
          if (xb<100){xb=100;}\
          if (ya<100){ya=100;}\
          if (yb<100){yb=100;}\
          if (xa>999){xa=999;}\
          if (xb>999){xb=999;}\
          if (ya>999){ya=999;}\
          if (yb>999){yb=999;}\
          document.getElementById('printForm').value += '_'+xa +'.'+ ya +'.'+ xb +'.'+ yb;\
          mUs.innerText   = 'SPEICHER:'+Math.round(xLog.length*100/maxLines )+'%';\
          mUB.style.width = xLog.length/maxLines*size;\
        }\
          draw = false;\
          drawDot = false;\
      }\
      var distance = 0;\
      if (res == 'move') {\
        drawDot  = false;\
        var xNew = event.touches[0].clientX- canvas.offsetLeft;\
        var yNew = event.touches[0].clientY- canvas.offsetTop;\
        distance = Math.sqrt(( Math.abs((xNew-x))^2+ Math.abs((yNew-y))^2));\
        if (distance>2){\
          pX = x;\
          pY = y;\
          x = xNew;\
          y = yNew;\
        }\
      }\
      if (draw && distance > 2 && xLog.length<maxLines-2){\
        ctx.lineWidth = 2;\
        ctx.beginPath();\
        ctx.moveTo(pX,pY);\
        ctx.lineTo(x,y);\
        ctx.stroke();\
        xLog.push(pX/size);\
        xLog.push(x/size);\
        yLog.push(pY/size);\
        yLog.push(y/size);\
        xa = Math.round(pX/size*899+100);\
        ya = Math.round(pY/size*899+100);\
        xb = Math.round(x/size*899+100);\
        yb = Math.round(y/size*899+100);\
        if (xa<100){xa=100;}\
        if (xb<100){xb=100;}\
        if (ya<100){ya=100;}\
        if (yb<100){yb=100;}\
        if (xa>999){xa=999;}\
        if (xb>999){xb=999;}\
        if (ya>999){ya=999;}\
        if (yb>999){yb=999;}\
        document.getElementById('printForm').value += '_'+xa +'.'+ ya +'.'+ xb +'.'+ yb;\
        mUs.innerText   = 'SPEICHER:'+Math.round(xLog.length*100/maxLines)+'%';\
        mUB.style.width = xLog.length/maxLines*size;\
      }\
      if (res == 'down') {\
        draw = true;\
        x = event.touches[0].clientX- canvas.offsetLeft;\
        y = event.touches[0].clientY- canvas.offsetTop;\
        drawDot = true;\
      }\
    }\
    function empty() {\
      document.getElementById('printForm').value ='LINEDRAWING-';\
      while(xLog.length>0){\
        xLog.pop();\
        yLog.pop();\
      }\
      layout();\
    }\
    </script>\
    <body onload='init()' onresize='layout()'>\
        <div id='headline'>MALE WAS SCHÖNES!</div>\
        <canvas id='can'></canvas>\
        <input type='button' value='LÖSCHEN' id='clear' onclick='empty()'>\
        <form action='/print' method = 'POST' autocomplete='off'>\
          <textarea  name = 'text' autofocus id='printForm'></textarea>\
          <input type = 'submit' id='print' value = 'DRUCKEN' />\
        </form>\
        <div id='memUse'></div>\
        <div id='memUseBar'></div>\
    </body>\
</html>\
  ";

  wsPrint = "\
  <html>\
    <meta name='theme-color' content='#00cccc' />\
    <meta http-equiv='content-type' content='text/html; charset=utf-8'>\
    <meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no' />\
    <meta name='HandheldFriendly' content='true' />\
    <style>\
        body        {background-color:yellow;margin:0;padding:0;font-family: monospace;}\
        #headline   {position: absolute; color: black;text-align: center;}\
    </style>\
    <script type='text/javascript'>\
    var size;\
    function layout(){\
      var sW =  window.innerWidth;\
      var sH =  window.innerHeight;\
      if (sW < sH) {size = sW*.9;}else{size = sH*.6;}\
      var left = sW/2 - size/2;\
      hea = document.getElementById('headline');\
      hea.style.width       = sW ;\
      hea.style.left        = 0;\
      hea.style.top         = sH*.45;\
      hea.style.fontSize    = size * .08 +'px';\
    }\
    </script>\
    <body onload='layout()' onresize='layout()'>\
        <div id='headline'>VIELEN DANK!</div>\
    </body>\
</html>\
";
}
