

// -------------------------------------------------------------------- serve writing form
void handleHome() {
  //s.println("SERVE DRAWING PROGRAM");
  server.send(200, "text/html", wsHome);
}
// -------------------------------------------------------------------- find and replace parts of a string
String findAndReplace(String originalString, String findString, String replaceString) {
  String returnString = "";

  for (int i = 0; i < originalString.length() - findString.length(); i++) {
    String focusWindow = originalString.substring(i, i + findString.length());

    if (focusWindow == findString) {
      returnString += replaceString;
      i += findString.length() - 1;
    } else {
      returnString += originalString.substring(i, i + 1);
    }
  }
  returnString += originalString.substring(originalString.length() - findString.length(), originalString.length());
  return returnString;
}

// -------------------------------------------------------------------- receive message, serve printing site
void handlePrint() {

  if (server.hasArg("plain") == false) {  //Check if body received
    server.send(200, "text/html", wsHome);
    return;
  }
  String message = server.arg("plain");
  if (message.substring(5, 16) == "LINEDRAWING" && message.length() > 20) {       // check header - if it's correct, send image via serial to Arduino:
  server.send(200, "text/html", wsPrint);             // serve thank you message
      s.print("START");                                    // new serial header for Arduino
      for (int i = 18; i < message.length() - 14; i += 16) { // send coordinates as bytes
        s.write((message.substring(i, i + 3).toInt() - 100) * 255 / 899);
        s.write((message.substring(i + 4, i + 7).toInt() - 100) * 255 / 899);
        s.write((message.substring(i + 8, i + 11).toInt() - 100) * 255 / 899);
        s.write((message.substring(i + 12, i + 15).toInt() - 100) * 255 / 899);
      }
      s.println("END");                                      // EOF
    
  }else{
      server.send(200, "text/html", wsHome);             // serve homepage again
    }
}
